SystemOrganization addCategory: #'Phidget-VMMaker-Plugins'!

SmartSyntaxInterpreterPlugin subclass: #PhidgetPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Phidget-VMMaker-Plugins'!

!PhidgetPlugin commentStamp: 'pt 5/3/2009 13:55' prior: 0!
A PhidgetPlugin is a plugin to enable the use of Phidgets (For more information about Phidgets see www.phidgets.com).

Instance Variables: - none -
!

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/6/2009 17:20'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^true! !

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 17:58'!
requiresCrossPlatformFiles
	"default is ok for most, any plugin needing platform specific files must say so"
	^true! !

!PhidgetPlugin class methodsFor: 'as yet unclassified' stamp: 'pt 4/18/2009 17:57'!
requiresPlatformFiles
	"this plugin requires platform specific files in order to work"
	^true! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/7/2009 13:42'!
ifKitValueOf: oop
	"Return a pointer to the first byte of the PhidgetIfKit record within the given Smalltalk bytes object, or nil if oop is not a PhidgetIfKit record."

	self returnTypeC: 'PhidgetIfKit *'.
	interpreterProxy success:
		( ( interpreterProxy isIntegerObject: oop ) not and:
		 [ ( interpreterProxy isBytes: oop ) and:
		 [ ( interpreterProxy slotSizeOf: oop ) = ( self cCode: 'sizeof(PhidgetIfKit)' ) ] ] ).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(PhidgetIfKit *) (oop + 4)'! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'sp 4/26/2009 13:03'!
initialiseModule
	"Initialise the module"

	self export: true.
	^ self cCode: '(sqInt) phidgetPlugin_Initialise()' inSmalltalk: [true]! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'lk 6/1/2009 19:14'!
phidgetValueOf: oop
	"Return a pointer to the first byte of the Phidget record within the given Smalltalk bytes object, or nil if oop is not a Phidget record."

	self returnTypeC: 'Phidget *'.
	interpreterProxy success:
		( ( interpreterProxy isIntegerObject: oop ) not and:
		 [ ( interpreterProxy isBytes: oop ) and:
		 [ ( interpreterProxy slotSizeOf: oop ) >= ( self cCode: 'sizeof(Phidget)' ) ] ] ).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(Phidget *) (oop + 4)'! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 6/1/2009 20:16'!
primGetAnalogSensorValue: phidHandle at: index

	| phid |
	self var: #phid type: 'Phidget *'.
	self primitive: 'primGetAnalogSensorValue' parameters: #(Oop SmallInteger ).
	
	phid := self phidgetValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf:
		( self cCode: 'phidgetComponent_AnalogSensor_GetValue(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 6/1/2009 20:15'!
primGetDigitalInputValue: phidHandle at: index

	| phid |
	self var: #phid type: 'Phidget *'.
	self primitive: 'primGetDigitalInputValue' parameters: #(Oop SmallInteger ).
	
	phid := self phidgetValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf:
		( self cCode: 'phidgetComponent_DigitalInput_GetValue(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 6/1/2009 20:35'!
primGetDigitalOutputValue: phidHandle at: index

	| phid |
	self var: #phid type: 'Phidget *'.
	self primitive: 'primGetDigitalOutputValue' parameters: #(Oop SmallInteger ).
	
	phid := self phidgetValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf:
		( self cCode: 'phidgetComponent_DigitalOutput_GetValue(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 6/1/2009 19:17'!
primGetIndexedIntegerSensitivity: phidgetHandle at: index

	| phid |
	self var: #phid type: 'Phidget *'.
	self primitive: 'primGetIndexedIntegerSensitivity' parameters: #(Oop SmallInteger).
	
	phid := self phidgetValueOf: phidgetHandle.
	^ self interpreterProxy integerObjectOf:
		( self cCode: 'phidgetComponent_GetIndexedIntegerSensitivity(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/3/2009 20:22'!
primIfKitAttached: ifKitHandle

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitAttached' parameters: #(Oop ).
	
	phid := self ifKitValueOf: ifKitHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_Attached((Phidget *)phid)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/3/2009 20:22'!
primIfKitClose: phidHandle

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitClose' parameters: #(Oop ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self cCode: 'phidgetIfKit_Close(phid)'! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/31/2009 11:51'!
primIfKitCreate

	| phidOop phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitCreate' parameters: #( ).
	
	phidOop := interpreterProxy
		instantiateClass: interpreterProxy classByteArray
		indexableSize: ( self cCode: 'sizeof(PhidgetIfKit)' ).
	phid := self ifKitValueOf: phidOop.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetIfKit_ResetSemaphores(phid)' ].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/7/2009 13:54'!
primIfKitGetSensorChangeTrigger: phidHandle at: index

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitGetSensorChangeTrigger' parameters: #(Oop SmallInteger).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetIfKit_GetSensorChangeTrigger(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/7/2009 13:40'!
primIfKitInputValue: phidHandle at: index

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitInputValue' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetIfKit_GetInputState(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/31/2009 16:31'!
primIfKitNumInputs: phidHandle

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitNumInputs' parameters: #(Oop ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetIfKit_NumInputs(phid)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/3/2009 20:23'!
primIfKitNumOutputs: phidHandle

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitNumOutputs' parameters: #(Oop ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetIfKit_NumOutputs(phid)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/3/2009 19:45'!
primIfKitNumSensors: phidHandle

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitNumSensors' parameters: #(Oop ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetIfKit_NumSensors(phid)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/5/2009 16:56'!
primIfKitOnAttached: phidHandle semaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitOnAttached' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_SetSemaIndexAttached((Phidget *)phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/5/2009 16:57'!
primIfKitOnDetached: phidHandle semaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitOnDetached' parameters: #(Oop SmallInteger ).

	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_SetSemaIndexDetached((Phidget *)phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/5/2009 16:57'!
primIfKitOnError: phidHandle semaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitOnError' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_SetSemaIndexError((Phidget *)phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/5/2009 16:57'!
primIfKitOnInputChanged: phidHandle semaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitOnInputChanged' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetIfKit_SetSemaIndexInputChanged(phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/5/2009 16:57'!
primIfKitOnOutputChanged: phidHandle semaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitOnOutputChanged' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetIfKit_SetSemaIndexOutputChanged(phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/5/2009 16:58'!
primIfKitOnSensorChanged: phidHandle semaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitOnSensorChanged' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidgetIfKit_SetSemaIndexSensorChanged(phid, (int)semaIndex)')! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/3/2009 19:48'!
primIfKitOpen: phidOop withSerial: serial

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitOpen' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidOop.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetIfKit_Open(phid, (int)serial)' ].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/3/2009 19:48'!
primIfKitOpenAny: phidOop

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitOpenAny' parameters: #(Oop ).
	
	phid := self ifKitValueOf: phidOop.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetIfKit_OpenAny(phid)' ].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/7/2009 13:41'!
primIfKitOutputValue: phidHandle at: index

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitOutputValue' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetIfKit_GetOutputState(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/3/2009 19:48'!
primIfKitSensorValue: phidHandle at: index

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitSensorValue' parameters: #(Oop SmallInteger ).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetIfKit_GetSensorValue(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/7/2009 13:42'!
primIfKitSetOutput: phidHandle at: index to: aNumber

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitSetOutput' parameters: #(Oop SmallInteger SmallInteger).
	
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetIfKit_SetOutputState(phid, (int)index, (int)aNumber)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 5/7/2009 13:52'!
primIfKitSetSensorChangeTrigger: phidHandle at: index to: aNumber

	| phid |
	self var: #phid type: 'PhidgetIfKit *'.
	self primitive: 'primIfKitSetSensorChangeTrigger' parameters: #(#Oop #SmallInteger #SmallInteger ).
	phid := self ifKitValueOf: phidHandle.
	^ self interpreterProxy
		integerObjectOf: (self cCode: 'phidgetIfKit_SetSensorChangeTrigger(phid, (int)index, (int)aNumber)')! !

!PhidgetPlugin methodsFor: 'Phidget common' stamp: 'sp 4/26/2009 13:20'!
primLastError

	self primitive: 'primLastError' parameters: #( ).
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_LastError()' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 6/1/2009 19:23'!
primNumAnalogSensors: phidgetHandle

	| phid |
	self var: #phid type: 'Phidget *'.
	self primitive: 'primNumAnalogSensors' parameters: #(Oop ).
	
	phid := self phidgetValueOf: phidgetHandle.
	^ self interpreterProxy integerObjectOf:
		( self cCode: 'phidgetComponent_AnalogSensor_GetCount(phid)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 6/1/2009 20:39'!
primNumDigitalInputs: phidgetHandle

	| phid |
	self var: #phid type: 'Phidget *'.
	self primitive: 'primNumDigitalInputs' parameters: #(Oop ).
	
	phid := self phidgetValueOf: phidgetHandle.
	^ self interpreterProxy integerObjectOf:
		( self cCode: 'phidgetComponent_DigitalInput_GetCount(phid)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 6/1/2009 20:39'!
primNumDigitalOutputs: phidgetHandle

	| phid |
	self var: #phid type: 'Phidget *'.
	self primitive: 'primNumDigitalOutputs' parameters: #(Oop ).
	
	phid := self phidgetValueOf: phidgetHandle.
	^ self interpreterProxy integerObjectOf:
		( self cCode: 'phidgetComponent_DigitalOutput_GetCount(phid)' )! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:17'!
primRFIDAttached: rfidHandle

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDAttached' parameters: #(Oop ).
	
	phid := self rfidValueOf: rfidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_Attached((Phidget *)phid)' )! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:17'!
primRFIDClose: rfidHandle

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDClose' parameters: #(Oop ).
	
	phid := self rfidValueOf: rfidHandle.
	^ self cCode: 'phidgetRFID_Close(phid)'! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:18'!
primRFIDCreate

	| phidOop phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDCreate' parameters: #( ).
	
	phidOop := interpreterProxy instantiateClass: interpreterProxy 
		classByteArray indexableSize: ( self cCode: 'sizeof(PhidgetRFID)' ).
	phid := self rfidValueOf: phidOop.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetRFID_ResetSemaphores(phid)' ].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/31/2009 19:20'!
primRFIDGetLastTag: phidHandle

	| arrayOop array phid |
	self var: #array type: 'char *'.
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDGetLastTag' parameters: #(Oop ).
	
	phid := self rfidValueOf: phidHandle.
	
	arrayOop := interpreterProxy
		instantiateClass: interpreterProxy classByteArray
		indexableSize: 5.
	array := self cCode: '(char *) (arrayOop + 4)'.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetRFID_GetLastTag(phid, array)' ].
	^ arrayOop! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/31/2009 18:36'!
primRFIDHasTag: phidHandle

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDHasTag' parameters: #(Oop ).
	
	phid := self rfidValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetRFID_HasTag(phid)' )! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:45'!
primRFIDIsAntennaOn: phidHandle

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDIsAntennaOn' parameters: #(Oop).
	
	phid := self rfidValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetRFID_IsAntennaOn(phid)' )! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:38'!
primRFIDIsLedOn: phidHandle

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDIsLedOn' parameters: #(Oop).
	
	phid := self rfidValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetRFID_IsLedOn(phid)' )! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:20'!
primRFIDNumOutputs: phidHandle

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDNumOutputs' parameters: #(Oop ).
	
	phid := self rfidValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetRFID_NumOutputs(phid)' )! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:18'!
primRFIDOnAttached: phidHandle semaphoreIndex: semaIndex 

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDOnAttached' parameters: #(#Oop #SmallInteger ).
	
	phid := self rfidValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidget_SetSemaIndexAttached((Phidget *)phid, (int)semaIndex)')! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:19'!
primRFIDOnDetached: phidHandle semaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDOnDetached' parameters: #(Oop SmallInteger ).

	phid := self rfidValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_SetSemaIndexDetached((Phidget *)phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:19'!
primRFIDOnError: phidHandle semaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDOnError' parameters: #(Oop SmallInteger ).
	
	phid := self rfidValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_SetSemaIndexError((Phidget *)phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:21'!
primRFIDOnOutputChanged: phidHandle semaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDOnOutputChanged' parameters: #(Oop SmallInteger ).
	
	phid := self rfidValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetRFID_SetSemaIndexOutputChanged(phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:21'!
primRFIDOnTagFound: phidHandle semaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDOnTagFound' parameters: #(Oop SmallInteger ).
	
	phid := self rfidValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetRFID_SetSemaIndexTagFound(phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:22'!
primRFIDOnTagLost: phidHandle semaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDOnTagLost' parameters: #(Oop SmallInteger ).
	
	phid := self rfidValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetRFID_SetSemaIndexTagLost(phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:19'!
primRFIDOpen: phidOop withSerial: serial

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDOpen' parameters: #(Oop SmallInteger ).
	
	phid := self rfidValueOf: phidOop.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetRFID_Open(phid, (int)serial)' ].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:20'!
primRFIDOpenAny: phidOop

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDOpenAny' parameters: #(Oop ).
	
	phid := self rfidValueOf: phidOop.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetRFID_OpenAny(phid)' ].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:22'!
primRFIDOutputValue: phidHandle at: index

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDOutputValue' parameters: #(Oop SmallInteger ).
	
	phid := self rfidValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetRFID_GetOutputState(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 21:01'!
primRFIDSetAntennaState: phidHandle to: anInteger

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDSetAntennaState' parameters: #(Oop SmallInteger).
	
	phid := self rfidValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetRFID_SetAntennaState(phid, (int)anInteger)' )! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 21:01'!
primRFIDSetLedState: phidHandle to: anInteger

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDSetLedState' parameters: #(Oop SmallInteger).
	
	phid := self rfidValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetRFID_SetLedState(phid, (int)anInteger)' )! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:26'!
primRFIDSetOutput: phidHandle at: index to: aNumber

	| phid |
	self var: #phid type: 'PhidgetRFID *'.
	self primitive: 'primRFIDSetOutput' parameters: #(Oop SmallInteger SmallInteger).
	
	phid := self rfidValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetRFID_SetOutputState(phid, (int)index, (int)aNumber)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/3/2009 20:24'!
primServoAttached: servoHandle

	| phid |
	self var: #phid type: 'PhidgetServo *'.
	self primitive: 'primServoAttached' parameters: #(Oop ).
	
	phid := self servoValueOf: servoHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_Attached((Phidget *)phid)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/3/2009 20:24'!
primServoClose: phidHandle

	| phid |
	self var: #phid type: 'PhidgetServo *'.
	self primitive: 'primServoClose' parameters: #(Oop ).
	
	phid := self servoValueOf: phidHandle.
	^ self cCode: 'phidgetServo_Close(phid)'! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/3/2009 19:49'!
primServoCreate

	| phidOop phid |
	self var: #phid type: 'PhidgetServo *'.
	self primitive: 'primServoCreate' parameters: #( ).
	
	phidOop := interpreterProxy instantiateClass: interpreterProxy 
		classByteArray indexableSize: ( self cCode: 'sizeof(PhidgetServo)' ).
	phid := self servoValueOf: phidOop.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetServo_ResetSemaphores(phid)' ].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/3/2009 20:24'!
primServoGetEngaged: servoHandle at: index

	| phid |
	self var: #phid type: 'PhidgetServo *'.
	self primitive: 'primServoGetEngaged' parameters: #(Oop SmallInteger).
	
	phid := self servoValueOf: servoHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetServo_GetEngaged(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/3/2009 20:15'!
primServoGetPosition: phidHandle at: index

	| phid |
	self var: #phid type: 'PhidgetServo *'.
	self primitive: 'primServoGetPosition' parameters: #(Oop SmallInteger ).
	
	phid := self servoValueOf: phidHandle.
	^ interpreterProxy floatObjectOf: ( self cCode: 'phidgetServo_GetPosition(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/3/2009 20:15'!
primServoGetPositionMax: phidHandle at: index

	| phid |
	self var: #phid type: 'PhidgetServo *'.
	self primitive: 'primServoGetPositionMax' parameters: #(Oop SmallInteger ).
	
	phid := self servoValueOf: phidHandle.
	^ interpreterProxy floatObjectOf: ( self cCode: 'phidgetServo_GetPositionMax(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/3/2009 20:15'!
primServoGetPositionMin: phidHandle at: index

	| phid |
	self var: #phid type: 'PhidgetServo *'.
	self primitive: 'primServoGetPositionMin' parameters: #(Oop SmallInteger ).
	
	phid := self servoValueOf: phidHandle.
	^ interpreterProxy floatObjectOf: ( self cCode: 'phidgetServo_GetPositionMin(phid, (int)index)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/3/2009 20:21'!
primServoNumMotors: servoHandle

	| phid |
	self var: #phid type: 'PhidgetServo *'.
	self primitive: 'primServoNumMotors' parameters: #(Oop ).
	
	phid := self servoValueOf: servoHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetServo_NumMotors(phid)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/5/2009 17:04'!
primServoOnAttached: phidHandle semaphoreIndex: semaIndex 

	| phid |
	self var: #phid type: 'PhidgetServo *'.
	self primitive: 'primServoOnAttached' parameters: #(#Oop #SmallInteger ).
	
	phid := self servoValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: (self cCode: 'phidget_SetSemaIndexAttached((Phidget *)phid, (int)semaIndex)')! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/5/2009 17:04'!
primServoOnDetached: phidHandle semaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'PhidgetServo *'.
	self primitive: 'primServoOnDetached' parameters: #(Oop SmallInteger ).

	phid := self servoValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_SetSemaIndexDetached((Phidget *)phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/5/2009 17:04'!
primServoOnError: phidHandle semaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'PhidgetServo *'.
	self primitive: 'primServoOnError' parameters: #(Oop SmallInteger ).
	
	phid := self servoValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidget_SetSemaIndexError((Phidget *)phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/5/2009 17:04'!
primServoOnPositionChanged: phidHandle semaphoreIndex: semaIndex

	| phid |
	self var: #phid type: 'PhidgetServo *'.
	self primitive: 'primServoOnPositionChanged' parameters: #(Oop SmallInteger ).
	
	phid := self servoValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetServo_SetSemaIndexPositionChanged(phid, (int)semaIndex)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/3/2009 19:51'!
primServoOpen: phidOop withSerial: serial

	| phid |
	self var: #phid type: 'PhidgetServo *'.
	self primitive: 'primServoOpen' parameters: #(Oop SmallInteger ).
	
	phid := self servoValueOf: phidOop.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetServo_Open(phid, (int)serial)' ].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/3/2009 19:51'!
primServoOpenAny: phidOop

	| phid |
	self var: #phid type: 'PhidgetServo *'.
	self primitive: 'primServoOpenAny' parameters: #(Oop ).
	
	phid := self servoValueOf: phidOop.
	interpreterProxy failed ifFalse: [ self cCode: 'phidgetServo_OpenAny(phid)' ].
	^ phidOop! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/3/2009 19:51'!
primServoSetEngaged: servoHandle at: index to: value

	| phid |
	self var: #phid type: 'PhidgetServo *'.
	self primitive: 'primServoSetEngaged' parameters: #(Oop SmallInteger SmallInteger ).
	
	interpreterProxy success: (value<=1 and: [ value >=0 ]).
	interpreterProxy failed ifTrue: [^ nil].
	phid := self servoValueOf: servoHandle.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetServo_SetEngaged(phid, (int)index, value)' )! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/14/2009 21:38'!
primServoSetPosition: phidHandle at: index to: value

	| phid floatValue |
	self var: #phid type: 'PhidgetServo *'.
	self var: #floatValue type: 'double'.
	self primitive: 'primServoSetPosition' parameters: #(Oop SmallInteger Oop ).
	
	phid := self servoValueOf: phidHandle.
	floatValue := interpreterProxy floatValueOf: value.
	^ self interpreterProxy integerObjectOf: ( self cCode: 'phidgetServo_SetPosition(phid, (int)index, floatValue)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 6/1/2009 20:38'!
primSetDigitalOutputValue: phidHandle at: index to: value

	| phid |
	self var: #phid type: 'Phidget *'.
	self primitive: 'primSetDigitalOutputValue' parameters: #(Oop SmallInteger SmallInteger).
	
	phid := self phidgetValueOf: phidHandle.
	^ self interpreterProxy integerObjectOf:
		( self cCode: 'phidgetComponent_DigitalOutput_SetValue(phid, (int)index, (int)value)' )! !

!PhidgetPlugin methodsFor: 'Interface Kit' stamp: 'lk 6/1/2009 20:36'!
primSetSensitivity: phidgetHandle at: index to: anInteger

	| phid |
	self var: #phid type: 'Phidget *'.
	self primitive: 'primSetIndexedIntegerSensitivity' parameters: #(#Oop #SmallInteger #SmallInteger ).
	phid := self phidgetValueOf: phidgetHandle.
	^ self interpreterProxy integerObjectOf:
		(self cCode: 'phidgetComponent_SetIndexedIntegerSensitivity(phid, (int)index, (int)anInteger)')! !

!PhidgetPlugin methodsFor: 'RFID' stamp: 'lk 5/30/2009 20:16'!
rfidValueOf: oop
	"Return a pointer to the first byte of the PhidgetRFID record within the given Smalltalk bytes object, or nil if oop is not a PhidgetRFID record."

	self returnTypeC: 'PhidgetRFID *'.
	interpreterProxy success:
		( ( interpreterProxy isIntegerObject: oop ) not and:
		 [ ( interpreterProxy isBytes: oop ) and:
		 [ ( interpreterProxy slotSizeOf: oop ) = ( self cCode: 'sizeof(PhidgetRFID)' ) ] ] ).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(PhidgetRFID *) (oop + 4)'! !

!PhidgetPlugin methodsFor: 'Servo' stamp: 'lk 5/3/2009 19:52'!
servoValueOf: oop
	"Return a pointer to the first byte of the Phidget_servo record within the given Smalltalk bytes object, or nil if oop is not a Phidget_servo record."

	self returnTypeC: 'PhidgetServo *'.
	interpreterProxy success:
		( ( interpreterProxy isIntegerObject: oop ) not and:
		 [ ( interpreterProxy isBytes: oop ) and:
		 [ ( interpreterProxy slotSizeOf: oop ) = ( self cCode: 'sizeof(PhidgetServo)' ) ] ] ).
	interpreterProxy failed ifTrue: [^ nil].
	^ self cCode: '(PhidgetServo *) (oop + 4)'! !

!PhidgetPlugin methodsFor: 'Plugin common' stamp: 'sp 4/26/2009 13:20'!
shutdownModule
	"Shutdown the module"
	
	self export: true.
	^ self cCode: '(sqInt) phidgetPlugin_Shutdown()' inSmalltalk: [true]! !
